diff --git a/app/Exceptions/Handler.php b/app/Exceptions/Handler.php
index 67e5bc4..b6d5393 100644
--- a/app/Exceptions/Handler.php
+++ b/app/Exceptions/Handler.php
@@ -4,14 +4,12 @@ namespace Portal\Exceptions;
 
 use Exception;
 use Illuminate\Auth\Access\AuthorizationException;
-use Illuminate\Auth\AuthenticationException;
 use Illuminate\Database\Eloquent\ModelNotFoundException;
 use Illuminate\Http\Exception\HttpResponseException;
 use Illuminate\Session\TokenMismatchException;
-use Illuminate\Validation\ValidationException;
 use Symfony\Component\HttpKernel\Exception\HttpException;
+use Illuminate\Foundation\Validation\ValidationException;
 use Illuminate\Foundation\Exceptions\Handler as ExceptionHandler;
-use Symfony\Component\HttpKernel\Exception\NotFoundHttpException;
 
 class Handler extends ExceptionHandler
 {
@@ -37,7 +35,7 @@ class Handler extends ExceptionHandler
      */
     public function report(Exception $e)
     {
-        parent::report($e);
+        return parent::report($e);
     }
 
     /**
@@ -57,7 +55,7 @@ class Handler extends ExceptionHandler
             $e = new HttpException(403, $e->getMessage());
         } elseif ($e instanceof ValidationException && $e->getResponse()) {
             return $e->getResponse();
-        } elseif ($e instanceof TokenMismatchException) {
+        } elseif ($e instanceof TokenMismatchException){
             return response()->view('errors.token-mismatch', [], 500);
         }
 
@@ -69,20 +67,4 @@ class Handler extends ExceptionHandler
             ? $this->toIlluminateResponse($this->convertExceptionToResponse($e), $e)
             : response()->view('errors.500', [], 500);
     }
-
-    /**
-     * Convert an authentication exception into an unauthenticated response.
-     *
-     * @param  \Illuminate\Http\Request  $request
-     * @param  \Illuminate\Auth\AuthenticationException  $exception
-     * @return \Illuminate\Http\Response
-     */
-    protected function unauthenticated($request, AuthenticationException $exception)
-    {
-        if ($request->expectsJson()) {
-            return response()->json(['error' => 'Unauthenticated.'], 401);
-        }
-
-        return redirect()->guest('login');
-    }
 }
diff --git a/app/Http/Controllers/ActivityController.php b/app/Http/Controllers/ActivityController.php
index 66affea..c9dc82e 100644
--- a/app/Http/Controllers/ActivityController.php
+++ b/app/Http/Controllers/ActivityController.php
@@ -3,7 +3,6 @@
 namespace Portal\Http\Controllers;
 
 use Portal\Repositories\Activity\ActivityRepository;
-use Portal\Repositories\Activity\EloquentActivity;
 use Portal\User;
 use Illuminate\Http\Request;
 
diff --git a/app/Http/Controllers/Auth/PasswordController.php b/app/Http/Controllers/Auth/PasswordController.php
index 53bfbf9..b2e1e9b 100644
--- a/app/Http/Controllers/Auth/PasswordController.php
+++ b/app/Http/Controllers/Auth/PasswordController.php
@@ -2,15 +2,13 @@
 
 namespace Portal\Http\Controllers\Auth;
 
-use Illuminate\Http\RedirectResponse;
-use Symfony\Component\HttpKernel\Exception\NotFoundHttpException;
 use Portal\Events\User\RequestedPasswordResetEmail;
 use Portal\Events\User\ResetedPasswordViaEmail;
 use Portal\Http\Controllers\Controller;
 use Portal\Http\Requests\Auth\PasswordRemindRequest;
 use Portal\Http\Requests\Auth\PasswordResetRequest;
-use Portal\Notifications\ResetPassword;
-use Portal\Repositories\User\UserRepository;
+use Portal\Mailers\UserMailer;
+use Portal\User;
 use Password;
 
 class PasswordController extends Controller
@@ -38,16 +36,16 @@ class PasswordController extends Controller
      * Send a reset link to the given user.
      *
      * @param PasswordRemindRequest $request
-     * @param UserRepository $users
+     * @param UserMailer $mailer
      * @return \Illuminate\Http\Response
      */
-    public function sendPasswordReminder(PasswordRemindRequest $request, UserRepository $users)
+    public function sendPasswordReminder(PasswordRemindRequest $request, UserMailer $mailer)
     {
-        $user = $users->findByEmail($request->email);
+        $user = User::where('email', $request->get('email'))->first();
 
         $token = Password::getRepository()->create($user);
 
-        $user->notify(new ResetPassword($token));
+        $mailer->sendPasswordReminder($user, $token);
 
         event(new RequestedPasswordResetEmail($user));
 
@@ -59,7 +57,7 @@ class PasswordController extends Controller
      * Display the password reset view for the given token.
      *
      * @param  string $token
-     * @return \Illuminate\Contracts\View\View
+     * @return \Illuminate\Http\Response
      * @throws NotFoundHttpException
      */
     public function getReset($token = null)
@@ -75,7 +73,7 @@ class PasswordController extends Controller
      * Reset the given user's password.
      *
      * @param PasswordResetRequest $request
-     * @return \Illuminate\Http\Response|RedirectResponse
+     * @return \Illuminate\Http\Response
      */
     public function postReset(PasswordResetRequest $request)
     {
diff --git a/app/Http/Controllers/InstallController.php b/app/Http/Controllers/InstallController.php
index 6205e9d..c2e61dc 100644
--- a/app/Http/Controllers/InstallController.php
+++ b/app/Http/Controllers/InstallController.php
@@ -142,7 +142,6 @@ class InstallController extends Controller
             'PDO MySQL Extension' => extension_loaded('pdo_mysql'),
             'Mbstring Extension'  => extension_loaded('mbstring'),
             'Tokenizer Extension' => extension_loaded('tokenizer'),
-            'XML Extension' => extension_loaded('xml'),
             'GD Extension' => extension_loaded('gd'),
             'Fileinfo Extension' => extension_loaded('fileinfo')
         ];
diff --git a/app/Http/Controllers/ProfileController.php b/app/Http/Controllers/ProfileController.php
index cd9d20c..d5117cf 100644
--- a/app/Http/Controllers/ProfileController.php
+++ b/app/Http/Controllers/ProfileController.php
@@ -47,11 +47,7 @@ class ProfileController extends Controller
         $this->middleware('session.database', ['only' => ['sessions', 'invalidateSession']]);
 
         $this->users = $users;
-
-        $this->middleware(function ($request, $next) {
-            $this->theUser = Auth::user();
-            return $next($request);
-        });
+        $this->theUser = Auth::user();
     }
 
     /**
diff --git a/app/Http/Controllers/UsersController.php b/app/Http/Controllers/UsersController.php
index caae686..1e9504c 100644
--- a/app/Http/Controllers/UsersController.php
+++ b/app/Http/Controllers/UsersController.php
@@ -88,7 +88,7 @@ class UsersController extends Controller
      */
     public function create(CountryRepository $countryRepository, RoleRepository $roleRepository)
     {
-        $countries = $this->parseCountries($countryRepository);
+        $countries = $countryRepository->lists();
         $roles = $roleRepository->lists();
         $statuses = UserStatus::lists();
 
@@ -96,18 +96,6 @@ class UsersController extends Controller
     }
 
     /**
-     * Parse countries into an array that also has a blank
-     * item as first element, which will allow users to
-     * leave the country field unpopulated.
-     * @param CountryRepository $countryRepository
-     * @return array
-     */
-    private function parseCountries(CountryRepository $countryRepository)
-    {
-        return [0 => 'Select a Country'] + $countryRepository->lists()->toArray();
-    }
-
-    /**
      * Stores new user into the database.
      *
      * @param CreateUserRequest $request
@@ -144,7 +132,7 @@ class UsersController extends Controller
     public function edit(User $user, CountryRepository $countryRepository, RoleRepository $roleRepository)
     {
         $edit = true;
-        $countries = $this->parseCountries($countryRepository);
+        $countries = $countryRepository->lists();
         $socials = $user->socialNetworks;
         $roles = $roleRepository->lists();
         $statuses = UserStatus::lists();
diff --git a/app/Http/Kernel.php b/app/Http/Kernel.php
index d1cee55..b53167b 100644
--- a/app/Http/Kernel.php
+++ b/app/Http/Kernel.php
@@ -29,11 +29,9 @@ class Kernel extends HttpKernel
             \Illuminate\Session\Middleware\StartSession::class,
             \Illuminate\View\Middleware\ShareErrorsFromSession::class,
             \Portal\Http\Middleware\VerifyCsrfToken::class,
-            \Illuminate\Routing\Middleware\SubstituteBindings::class,
         ],
         'api' => [
             'throttle:60,1',
-            'bindings'
         ],
     ];
 
@@ -51,8 +49,6 @@ class Kernel extends HttpKernel
         'role' => \Zizaco\Entrust\Middleware\EntrustRole::class,
         'permission' => \Zizaco\Entrust\Middleware\EntrustPermission::class,
         'ability' => \Zizaco\Entrust\Middleware\EntrustAbility::class,
-        'session.database' => \Portal\Http\Middleware\DatabaseSession::class,
-        'can' => \Illuminate\Auth\Middleware\Authorize::class,
-        'bindings' => \Illuminate\Routing\Middleware\SubstituteBindings::class,
+        'session.database' => \Portal\Http\Middleware\DatabaseSession::class
     ];
 }
diff --git a/app/Http/routes.php b/app/Http/routes.php
new file mode 100644
index 0000000..22203c5
--- /dev/null
+++ b/app/Http/routes.php
@@ -0,0 +1,378 @@
+<?php
+
+/**
+ * Authentication
+ */
+
+Route::get('login', 'Auth\AuthController@getLogin');
+Route::post('login', 'Auth\AuthController@postLogin');
+
+Route::get('logout', [
+    'as' => 'auth.logout',
+    'uses' => 'Auth\AuthController@getLogout'
+]);
+
+// Allow registration routes only if registration is enabled.
+if (settings('reg_enabled')) {
+    Route::get('register', 'Auth\AuthController@getRegister');
+    Route::post('register', 'Auth\AuthController@postRegister');
+    Route::get('register/confirmation/{token}', [
+        'as' => 'register.confirm-email',
+        'uses' => 'Auth\AuthController@confirmEmail'
+    ]);
+}
+
+// Register password reset routes only if it is enabled inside website settings.
+if (settings('forgot_password')) {
+    Route::get('password/remind', 'Auth\PasswordController@forgotPassword');
+    Route::post('password/remind', 'Auth\PasswordController@sendPasswordReminder');
+    Route::get('password/reset/{token}', 'Auth\PasswordController@getReset');
+    Route::post('password/reset', 'Auth\PasswordController@postReset');
+}
+
+/**
+ * Two-Factor Authentication
+ */
+if (settings('2fa.enabled')) {
+    Route::get('auth/two-factor-authentication', [
+        'as' => 'auth.token',
+        'uses' => 'Auth\AuthController@getToken'
+    ]);
+
+    Route::post('auth/two-factor-authentication', [
+        'as' => 'auth.token.validate',
+        'uses' => 'Auth\AuthController@postToken'
+    ]);
+}
+
+/**
+ * Social Login
+ */
+Route::get('auth/{provider}/login', [
+    'as' => 'social.login',
+    'uses' => 'Auth\SocialAuthController@redirectToProvider',
+    'middleware' => 'social.login'
+]);
+
+Route::get('auth/{provider}/callback', 'Auth\SocialAuthController@handleProviderCallback');
+
+Route::get('auth/twitter/email', 'Auth\SocialAuthController@getTwitterEmail');
+Route::post('auth/twitter/email', 'Auth\SocialAuthController@postTwitterEmail');
+
+/**
+ * Other
+ */
+
+Route::get('/', [
+    'as' => 'dashboard',
+    'uses' => 'DashboardController@index'
+]);
+
+/**
+ * User Profile
+ */
+
+Route::get('profile', [
+    'as' => 'profile',
+    'uses' => 'ProfileController@index'
+]);
+
+Route::get('profile/activity', [
+    'as' => 'profile.activity',
+    'uses' => 'ProfileController@activity'
+]);
+
+Route::put('profile/details/update', [
+    'as' => 'profile.update.details',
+    'uses' => 'ProfileController@updateDetails'
+]);
+
+Route::post('profile/avatar/update', [
+    'as' => 'profile.update.avatar',
+    'uses' => 'ProfileController@updateAvatar'
+]);
+
+Route::post('profile/avatar/update/external', [
+    'as' => 'profile.update.avatar-external',
+    'uses' => 'ProfileController@updateAvatarExternal'
+]);
+
+Route::put('profile/login-details/update', [
+    'as' => 'profile.update.login-details',
+    'uses' => 'ProfileController@updateLoginDetails'
+]);
+
+Route::put('profile/social-networks/update', [
+    'as' => 'profile.update.social-networks',
+    'uses' => 'ProfileController@updateSocialNetworks'
+]);
+
+Route::post('profile/two-factor/enable', [
+    'as' => 'profile.two-factor.enable',
+    'uses' => 'ProfileController@enableTwoFactorAuth'
+]);
+
+Route::post('profile/two-factor/disable', [
+    'as' => 'profile.two-factor.disable',
+    'uses' => 'ProfileController@disableTwoFactorAuth'
+]);
+
+Route::get('profile/sessions', [
+    'as' => 'profile.sessions',
+    'uses' => 'ProfileController@sessions'
+]);
+
+Route::delete('profile/sessions/{session}/invalidate', [
+    'as' => 'profile.sessions.invalidate',
+    'uses' => 'ProfileController@invalidateSession'
+]);
+
+/**
+ * User Management
+ */
+Route::get('user', [
+    'as' => 'user.list',
+    'uses' => 'UsersController@index'
+]);
+
+Route::get('user/create', [
+    'as' => 'user.create',
+    'uses' => 'UsersController@create'
+]);
+
+Route::post('user/create', [
+    'as' => 'user.store',
+    'uses' => 'UsersController@store'
+]);
+
+Route::get('user/{user}/show', [
+    'as' => 'user.show',
+    'uses' => 'UsersController@view'
+]);
+
+Route::get('user/{user}/edit', [
+    'as' => 'user.edit',
+    'uses' => 'UsersController@edit'
+]);
+
+Route::put('user/{user}/update/details', [
+    'as' => 'user.update.details',
+    'uses' => 'UsersController@updateDetails'
+]);
+
+Route::put('user/{user}/update/login-details', [
+    'as' => 'user.update.login-details',
+    'uses' => 'UsersController@updateLoginDetails'
+]);
+
+Route::delete('user/{user}/delete', [
+    'as' => 'user.delete',
+    'uses' => 'UsersController@delete'
+]);
+
+Route::post('user/{user}/update/avatar', [
+    'as' => 'user.update.avatar',
+    'uses' => 'UsersController@updateAvatar'
+]);
+
+Route::post('user/{user}/update/avatar/external', [
+    'as' => 'user.update.avatar.external',
+    'uses' => 'UsersController@updateAvatarExternal'
+]);
+
+Route::post('user/{user}/update/social-networks', [
+    'as' => 'user.update.socials',
+    'uses' => 'UsersController@updateSocialNetworks'
+]);
+
+Route::get('user/{user}/sessions', [
+    'as' => 'user.sessions',
+    'uses' => 'UsersController@sessions'
+]);
+
+Route::delete('user/{user}/sessions/{session}/invalidate', [
+    'as' => 'user.sessions.invalidate',
+    'uses' => 'UsersController@invalidateSession'
+]);
+
+Route::post('user/{user}/two-factor/enable', [
+    'as' => 'user.two-factor.enable',
+    'uses' => 'UsersController@enableTwoFactorAuth'
+]);
+
+Route::post('user/{user}/two-factor/disable', [
+    'as' => 'user.two-factor.disable',
+    'uses' => 'UsersController@disableTwoFactorAuth'
+]);
+
+/**
+ * Roles & Permissions
+ */
+
+Route::get('role', [
+    'as' => 'role.index',
+    'uses' => 'RolesController@index'
+]);
+
+Route::get('role/create', [
+    'as' => 'role.create',
+    'uses' => 'RolesController@create'
+]);
+
+Route::post('role/store', [
+    'as' => 'role.store',
+    'uses' => 'RolesController@store'
+]);
+
+Route::get('role/{role}/edit', [
+    'as' => 'role.edit',
+    'uses' => 'RolesController@edit'
+]);
+
+Route::put('role/{role}/update', [
+    'as' => 'role.update',
+    'uses' => 'RolesController@update'
+]);
+
+Route::delete('role/{role}/delete', [
+    'as' => 'role.delete',
+    'uses' => 'RolesController@delete'
+]);
+
+
+Route::post('permission/save', [
+    'as' => 'permission.save',
+    'uses' => 'PermissionsController@saveRolePermissions'
+]);
+
+Route::resource('permission', 'PermissionsController');
+
+/**
+ * Settings
+ */
+
+Route::get('settings', [
+    'as' => 'settings.general',
+    'uses' => 'SettingsController@general',
+    'middleware' => 'permission:settings.general'
+]);
+
+Route::post('settings/general', [
+    'as' => 'settings.general.update',
+    'uses' => 'SettingsController@update',
+    'middleware' => 'permission:settings.general'
+]);
+
+Route::get('settings/auth', [
+    'as' => 'settings.auth',
+    'uses' => 'SettingsController@auth',
+    'middleware' => 'permission:settings.auth'
+]);
+
+Route::post('settings/auth', [
+    'as' => 'settings.auth.update',
+    'uses' => 'SettingsController@update',
+    'middleware' => 'permission:settings.auth'
+]);
+
+// Only allow managing 2FA if AUTHY_KEY is defined inside .env file
+if (env('AUTHY_KEY')) {
+    Route::post('settings/auth/2fa/enable', [
+        'as' => 'settings.auth.2fa.enable',
+        'uses' => 'SettingsController@enableTwoFactor',
+        'middleware' => 'permission:settings.auth'
+    ]);
+
+    Route::post('settings/auth/2fa/disable', [
+        'as' => 'settings.auth.2fa.disable',
+        'uses' => 'SettingsController@disableTwoFactor',
+        'middleware' => 'permission:settings.auth'
+    ]);
+}
+
+Route::post('settings/auth/registration/captcha/enable', [
+    'as' => 'settings.registration.captcha.enable',
+    'uses' => 'SettingsController@enableCaptcha',
+    'middleware' => 'permission:settings.auth'
+]);
+
+Route::post('settings/auth/registration/captcha/disable', [
+    'as' => 'settings.registration.captcha.disable',
+    'uses' => 'SettingsController@disableCaptcha',
+    'middleware' => 'permission:settings.auth'
+]);
+
+Route::get('settings/notifications', [
+    'as' => 'settings.notifications',
+    'uses' => 'SettingsController@notifications',
+    'middleware' => 'permission:settings.notifications'
+]);
+
+Route::post('settings/notifications', [
+    'as' => 'settings.notifications.update',
+    'uses' => 'SettingsController@update',
+    'middleware' => 'permission:settings.notifications'
+]);
+
+/**
+ * Activity Log
+ */
+
+Route::get('activity', [
+    'as' => 'activity.index',
+    'uses' => 'ActivityController@index'
+]);
+
+Route::get('activity/user/{user}/log', [
+    'as' => 'activity.user',
+    'uses' => 'ActivityController@userActivity'
+]);
+
+/**
+ * Installation
+ */
+
+$router->get('install', [
+    'as' => 'install.start',
+    'uses' => 'InstallController@index'
+]);
+
+$router->get('install/requirements', [
+    'as' => 'install.requirements',
+    'uses' => 'InstallController@requirements'
+]);
+
+$router->get('install/permissions', [
+    'as' => 'install.permissions',
+    'uses' => 'InstallController@permissions'
+]);
+
+$router->get('install/database', [
+    'as' => 'install.database',
+    'uses' => 'InstallController@databaseInfo'
+]);
+
+$router->get('install/start-installation', [
+    'as' => 'install.installation',
+    'uses' => 'InstallController@installation'
+]);
+
+$router->post('install/start-installation', [
+    'as' => 'install.installation',
+    'uses' => 'InstallController@installation'
+]);
+
+$router->post('install/install-app', [
+    'as' => 'install.install',
+    'uses' => 'InstallController@install'
+]);
+
+$router->get('install/complete', [
+    'as' => 'install.complete',
+    'uses' => 'InstallController@complete'
+]);
+
+$router->get('install/error', [
+    'as' => 'install.error',
+    'uses' => 'InstallController@error'
+]);
\ No newline at end of file
diff --git a/app/Listeners/UserWasRegisteredListener.php b/app/Listeners/UserWasRegisteredListener.php
index 750ec0e..9a08496 100644
--- a/app/Listeners/UserWasRegisteredListener.php
+++ b/app/Listeners/UserWasRegisteredListener.php
@@ -5,7 +5,6 @@ namespace Portal\Listeners;
 use Portal\Events\User\Registered;
 use Portal\Mailers\NotificationMailer;
 use Portal\Mailers\UserMailer;
-use Portal\Notifications\UserRegistered;
 use Portal\Repositories\User\UserRepository;
 use Illuminate\Queue\InteractsWithQueue;
 use Illuminate\Contracts\Queue\ShouldQueue;
@@ -13,12 +12,17 @@ use Illuminate\Contracts\Queue\ShouldQueue;
 class UserWasRegisteredListener
 {
     /**
+     * @var NotificationMailer
+     */
+    private $mailer;
+    /**
      * @var UserRepository
      */
     private $users;
 
-    public function __construct(UserRepository $users)
+    public function __construct(NotificationMailer $mailer, UserRepository $users)
     {
+        $this->mailer = $mailer;
         $this->users = $users;
     }
 
@@ -30,12 +34,10 @@ class UserWasRegisteredListener
      */
     public function handle(Registered $event)
     {
-        if (! settings('notifications_signup_email')) {
-            return;
-        }
+        if (! settings('notifications_signup_email')) return;
         
         foreach ($this->users->getUsersWithRole('Admin') as $user) {
-            $user->notify(new UserRegistered($event->getRegisteredUser()));
+            $this->mailer->newUserRegistration($user, $event->getRegisteredUser());
         }
     }
 }
diff --git a/app/Mailers/NotificationMailer.php b/app/Mailers/NotificationMailer.php
new file mode 100644
index 0000000..44edceb
--- /dev/null
+++ b/app/Mailers/NotificationMailer.php
@@ -0,0 +1,17 @@
+<?php
+
+namespace Portal\Mailers;
+
+use Portal\User;
+
+class NotificationMailer extends AbstractMailer
+{
+    public function newUserRegistration(User $recipient, User $newUser)
+    {
+        $view = 'emails.notifications.new-registration';
+        $data = ['user' => $recipient, 'newUser' => $newUser];
+        $subject = 'New User Registration';
+
+        $this->sendTo($recipient->email, $subject, $view, $data);
+    }
+}
\ No newline at end of file
diff --git a/app/Mailers/UserMailer.php b/app/Mailers/UserMailer.php
index ff0145a..0d3987f 100644
--- a/app/Mailers/UserMailer.php
+++ b/app/Mailers/UserMailer.php
@@ -2,19 +2,25 @@
 
 namespace Portal\Mailers;
 
-use Portal\Notifications\EmailConfirmation;
-use Portal\Notifications\ResetPassword;
 use Portal\User;
 
 class UserMailer extends AbstractMailer
 {
-    public function sendConfirmationEmail(User $user, $token)
+    public function sendConfirmationEmail($user, $token)
     {
-        $user->notify(new EmailConfirmation($token));
+        $view = 'emails.registration.confirmation';
+        $data = ['token' => $token];
+        $subject = 'Registration Confirmation';
+
+        $this->sendTo($user->email, $subject, $view, $data);
     }
 
     public function sendPasswordReminder(User $user, $token)
     {
-        $user->notify(new ResetPassword($token));
+        $view = 'emails.password.remind';
+        $data = ['user' => $user, 'token' => $token];
+        $subject = 'Password Reset Required';
+
+        $this->sendTo($user->email, $subject, $view, $data);
     }
-}
+}
\ No newline at end of file
diff --git a/app/Providers/AppServiceProvider.php b/app/Providers/AppServiceProvider.php
index b755d1b..de89c64 100644
--- a/app/Providers/AppServiceProvider.php
+++ b/app/Providers/AppServiceProvider.php
@@ -27,7 +27,6 @@ class AppServiceProvider extends ServiceProvider
     public function boot()
     {
         Carbon::setLocale(config('app.locale'));
-        config(['app.name' => settings('app_name')]);
     }
 
     /**
diff --git a/app/Providers/AuthServiceProvider.php b/app/Providers/AuthServiceProvider.php
index 0ebbd8a..ac9cdc0 100644
--- a/app/Providers/AuthServiceProvider.php
+++ b/app/Providers/AuthServiceProvider.php
@@ -19,10 +19,13 @@ class AuthServiceProvider extends ServiceProvider
     /**
      * Register any application authentication / authorization services.
      *
+     * @param  \Illuminate\Contracts\Auth\Access\Gate  $gate
      * @return void
      */
-    public function boot()
+    public function boot(GateContract $gate)
     {
+        parent::registerPolicies($gate);
+
         //
     }
 }
diff --git a/app/Providers/EventServiceProvider.php b/app/Providers/EventServiceProvider.php
index 6fc7052..a881423 100644
--- a/app/Providers/EventServiceProvider.php
+++ b/app/Providers/EventServiceProvider.php
@@ -7,6 +7,7 @@ use Portal\Listeners\PermissionEventsSubscriber;
 use Portal\Listeners\RoleEventsSubscriber;
 use Portal\Listeners\UserEventsSubscriber;
 use Portal\Listeners\UserWasRegisteredListener;
+use Illuminate\Contracts\Events\Dispatcher as DispatcherContract;
 use Illuminate\Foundation\Support\Providers\EventServiceProvider as ServiceProvider;
 
 class EventServiceProvider extends ServiceProvider
@@ -34,11 +35,12 @@ class EventServiceProvider extends ServiceProvider
     /**
      * Register any other events for your application.
      *
+     * @param  \Illuminate\Contracts\Events\Dispatcher  $events
      * @return void
      */
-    public function boot()
+    public function boot(DispatcherContract $events)
     {
-        parent::boot();
+        parent::boot($events);
 
         //
     }
diff --git a/app/Providers/RouteServiceProvider.php b/app/Providers/RouteServiceProvider.php
index ad8eb7d..15664e2 100644
--- a/app/Providers/RouteServiceProvider.php
+++ b/app/Providers/RouteServiceProvider.php
@@ -2,10 +2,10 @@
 
 namespace Portal\Providers;
 
-use Route;
 use Portal\Permission;
 use Portal\Repositories\Role\RoleRepository;
 use Portal\Repositories\User\UserRepository;
+use Portal\Role;
 use Illuminate\Routing\Router;
 use Illuminate\Foundation\Support\Providers\RouteServiceProvider as ServiceProvider;
 use Symfony\Component\HttpKernel\Exception\NotFoundHttpException;
@@ -24,26 +24,27 @@ class RouteServiceProvider extends ServiceProvider
     /**
      * Define your route model bindings, pattern filters, etc.
      *
+     * @param  \Illuminate\Routing\Router  $router
      * @return void
      */
-    public function boot()
+    public function boot(Router $router)
     {
-        parent::boot();
+        parent::boot($router);
 
-        $this->bindUser();
-        $this->bindRole();
+        $this->bindUser($router);
+        $this->bindRole($router);
+        $this->bindPermission($router);
     }
 
     /**
      * Define the routes for the application.
      *
+     * @param  \Illuminate\Routing\Router  $router
      * @return void
      */
-    public function map()
+    public function map(Router $router)
     {
-        $this->mapApiRoutes();
-
-        $this->mapWebRoutes();
+        $this->mapWebRoutes($router);
     }
 
     /**
@@ -51,50 +52,40 @@ class RouteServiceProvider extends ServiceProvider
      *
      * These routes all receive session state, CSRF protection, etc.
      *
+     * @param  \Illuminate\Routing\Router  $router
      * @return void
      */
-    protected function mapWebRoutes()
+    protected function mapWebRoutes(Router $router)
     {
-        Route::group([
-            'namespace' => $this->namespace,
-            'middleware' => 'web',
+        $router->group([
+            'namespace' => $this->namespace, 'middleware' => 'web',
         ], function ($router) {
-            require base_path('routes/web.php');
+            require app_path('Http/routes.php');
         });
     }
 
     /**
-     * Define the "api" routes for the application.
-     *
-     * These routes are typically stateless.
-     *
-     * @return void
+     * @param Router $router
      */
-    protected function mapApiRoutes()
+    private function bindUser(Router $router)
     {
-        Route::group([
-            'middleware' => 'api',
-            'namespace' => $this->namespace,
-            'prefix' => 'api',
-        ], function () {
-            require base_path('routes/api.php');
-        });
+        $this->bindUsingRepository($router, 'user', UserRepository::class);
     }
 
-    private function bindUser()
+    private function bindRole(Router $router)
     {
-        $this->bindUsingRepository('user', UserRepository::class);
+        $this->bindUsingRepository($router, 'role', RoleRepository::class);
     }
 
-    private function bindRole()
+    private function bindPermission($router)
     {
-        $this->bindUsingRepository('role', RoleRepository::class);
+        $router->model('permission', Permission::class);
     }
 
-    private function bindUsingRepository($entity, $repository, $method = 'find')
+    private function bindUsingRepository($router, $entity, $repositoryClass, $method = 'find')
     {
-        Route::bind($entity, function ($id) use ($repository, $method) {
-            if ($object = app($repository)->$method($id)) {
+        $router->bind($entity, function ($id) use($repositoryClass, $method) {
+            if ($object = app($repositoryClass)->$method($id)) {
                 return $object;
             }
 
diff --git a/app/Repositories/Activity/EloquentActivity.php b/app/Repositories/Activity/EloquentActivity.php
index 165edbc..789374d 100644
--- a/app/Repositories/Activity/EloquentActivity.php
+++ b/app/Repositories/Activity/EloquentActivity.php
@@ -42,7 +42,7 @@ class EloquentActivity implements ActivityRepository
      */
     public function paginateActivities($perPage = 20, $search = null)
     {
-        $query = Activity::with('user');
+        $query = Activity::query();
 
         return $this->paginateAndFilterResults($perPage, $search, $query);
     }
@@ -82,9 +82,9 @@ class EloquentActivity implements ActivityRepository
             ->whereBetween('created_at', [$from, $to])
             ->groupBy('day')
             ->orderBy('day', 'ASC')
-            ->pluck('count', 'day');
+            ->lists('count', 'day');
 
-        while (! $from->isSameDay($to)) {
+        while(! $from->isSameDay($to)) {
             if (! $result->has($from->toDateString())) {
                 $result->put($from->toDateString(), 0);
             }
diff --git a/app/Repositories/Country/EloquentCountry.php b/app/Repositories/Country/EloquentCountry.php
index 0577a13..04353e0 100644
--- a/app/Repositories/Country/EloquentCountry.php
+++ b/app/Repositories/Country/EloquentCountry.php
@@ -11,6 +11,6 @@ class EloquentCountry implements CountryRepository
      */
     public function lists($column = 'name', $key = 'id')
     {
-        return Country::orderBy('name')->pluck($column, $key);
+        return Country::orderBy('name')->lists($column, $key);
     }
-}
+}
\ No newline at end of file
diff --git a/app/Repositories/Role/EloquentRole.php b/app/Repositories/Role/EloquentRole.php
index 80c9dbb..64a8b2b 100644
--- a/app/Repositories/Role/EloquentRole.php
+++ b/app/Repositories/Role/EloquentRole.php
@@ -97,7 +97,7 @@ class EloquentRole implements RoleRepository
      */
     public function lists($column = 'name', $key = 'id')
     {
-        return Role::pluck($column, $key);
+        return Role::lists($column, $key);
     }
 
     /**
diff --git a/app/Repositories/Session/DbSession.php b/app/Repositories/Session/DbSession.php
index be1a74d..7dc9a6c 100644
--- a/app/Repositories/Session/DbSession.php
+++ b/app/Repositories/Session/DbSession.php
@@ -28,8 +28,7 @@ class DbSession implements SessionRepository
     {
         return DB::table('sessions')
             ->where('user_id', $userId)
-            ->get(['id', 'ip_address', 'user_agent', 'last_activity'])
-            ->all();
+            ->get(['id', 'ip_address', 'user_agent', 'last_activity']);
     }
 
     /**
